import { ExtensionProperty } from "@gltf-transform/core";
import { Texture } from "@gltf-transform/core";
import { TextureInfo } from "@gltf-transform/core";
import { IProperty } from "@gltf-transform/core";
import { PropertyType } from "@gltf-transform/core";
import { PropertyTable } from "./StructuralMetadata";
declare const NAME = "EXT_mesh_features";
interface IMeshFeatures extends IProperty {
    featureIds: FeatureId[];
}
interface IFeatureId extends IProperty {
    featureCount: number;
    nullFeatureId: number;
    label: string;
    attribute: FeatureIdAttribute;
    texture: FeatureIdTexture;
    propertyTable: PropertyTable;
}
type FeatureIdAttribute = number;
interface IFeatureIdTexture extends IProperty {
    channels: number[];
    texture: Texture;
    textureInfo: TextureInfo;
}
export declare class MeshFeatures extends ExtensionProperty<IMeshFeatures> {
    static EXTENSION_NAME: string;
    extensionName: typeof NAME;
    propertyType: "MeshFeatures";
    parentTypes: [PropertyType.PRIMITIVE];
    protected init(): void;
    protected getDefaults(): import("@gltf-transform/core").Nullable<IMeshFeatures> & {
        featureIds: never[];
    };
    listFeatureIds(): FeatureId[];
    addFeatureId(featureId: FeatureId): this;
    removeFeatureId(featureId: FeatureId): this;
}
export declare class FeatureId extends ExtensionProperty<IFeatureId> {
    static EXTENSION_NAME: string;
    extensionName: typeof NAME;
    propertyType: "FeatureId";
    parentTypes: ["MeshFeatures"];
    protected init(): void;
    protected getDefaults(): import("@gltf-transform/core").Nullable<IFeatureId>;
    getFeatureCount(): number;
    setFeatureCount(featureCount: number): this;
    getNullFeatureId(): number;
    setNullFeatureId(nullFeatureId: number): this;
    getLabel(): string;
    setLabel(label: string): this;
    getAttribute(): FeatureIdAttribute;
    setAttribute(attribute: FeatureIdAttribute): this;
    getTexture(): FeatureIdTexture | null;
    setTexture(texture: FeatureIdTexture | null): this;
    getPropertyTable(): PropertyTable | null;
    setPropertyTable(propertyTable: PropertyTable | null): this;
}
export declare class FeatureIdTexture extends ExtensionProperty<IFeatureIdTexture> {
    static EXTENSION_NAME: string;
    extensionName: typeof NAME;
    propertyType: "FeatureIdTexture";
    parentTypes: ["FeatureId"];
    protected init(): void;
    protected getDefaults(): import("@gltf-transform/core").Nullable<IFeatureIdTexture> & {
        channels: number[];
        texture: null;
        textureInfo: TextureInfo;
    };
    getChannels(): number[];
    setChannels(channels: number[]): this;
    getTexture(): Texture | null;
    setTexture(texture: Texture | null): this;
    getTextureInfo(): TextureInfo | null;
}
export {};
//# sourceMappingURL=MeshFeatures.d.ts.map